use strict;

use vars qw(%dir_list);
BEGIN { %dir_list = (
                        "Geometry" => "larcore_Geometry",
 			"Geometry_service" => "larcore_Geometry_Geometry_service",
			"AuxDetGeometry_service" => "larcore_Geometry_AuxDetGeometry_service",
			"DumpChannelMap_module" => "larcore_Geometry_DumpChannelMap_module",
			"StandardGeometryHelper_service" => "larcore_Geometry_StandardGeometryHelper_service",
                        "SummaryData" => "larcore_SummaryData",
			"SummaryData_dict" => "larcore_SummaryData_dict",
                        "AnalysisAlg" => "lardata_AnalysisAlg",
                        "AnalysisBase" => "lardata_AnalysisBase",
                        "DetectorInfo" => "lardata_DetectorInfo",
                        "MCBase" => "lardata_MCBase",
                        "OpticalDetectorData" => "lardata_OpticalDetectorData",
                        "RawData" => "lardata_RawData",
        		"RawData_utils" => "lardata_RawData_utils",
                        "RecoBase" => "lardata_RecoBase",
                        "RecoBase_dict" => "lardata_RecoBase_dict",
                        "RecoBaseArt" => "lardata_RecoBaseArt",
                        "RecoObjects" => "lardata_RecoObjects",
                        "Utilities" => "lardata_Utilities",
                        "DetectorProperties_service" => "",
			"lardata_Utilities_DetectorProperties_service" => "",
                        "ComputePi_module" => "lardata_Utilities_ComputePi_module",
                        "DatabaseUtil_service" => "lardata_Utilities_DatabaseUtil_service",
                        "FileCatalogMetadataExtras_service" => "lardata_Utilities_FileCatalogMetadataExtras_service",
                        "Utilities_LArFFT_service" => "lardata_Utilities_Utilities_LArFFT_service",
			"LArProperties_service" => "",
			"lardata_Utilities_LArProperties_service" => "",
                        "MemoryPeakReporter_service" => "lardata_Utilities_MemoryPeakReporter_service",
			"AnalysisBase_dict" => "lardata_AnalysisBase_dict",
			"MCBase_dict" => "lardata_MCBase_dict",
			"OpticalDetectorData_dict" => "lardata_OpticalDetectorData_dict",
			"ComputePi_module" => "lardata_Utilities_ComputePi_module",
			"FileCatalogMetadataExtras_service" => "lardata_Utilities_FileCatalogMetadataExtras_service",
			"LArFFT_service" => "lardata_Utilities_LArFFT_service",
			"MemoryPeakReporter_service" => "lardata_Utilities_MemoryPeakReporter_service",
			"LArPropertiesServiceArgoNeuT_service" => "lardata_Utilities_LArPropertiesServiceArgoNeuT_service",
			"DatabaseUtil_service" => "lardata_Utilities_DatabaseUtil_service",
			"TimeService_service" => "",
			"lardata_Utilities_TimeService_service" => "",
			"DetectorClocksServiceStandard_service" => "lardata_DetectorInfoServices_DetectorClocksServiceStandard_service",
			"DetectorPropertiesServiceStandard_service" => "lardata_DetectorInfoServices_DetectorPropertiesServiceStandard_service",
			"LArPropertiesServiceStandard_service" => "lardata_DetectorInfoServices_LArPropertiesServiceStandard_service",
			"LArRawInputSource_source" => "lardata_RawData_utils_LArRawInputSource_source",
			"LArPropTest_module" => "test_DetectorInfoServices_LArPropTest_module",
			"ServicePackTest_module" => "test_DetectorInfoServices_ServicePackTest_module",
        		"CalibrationDBI_IOVData" => "larevt_CalibrationDBI_IOVData",
		        "CalibrationDBI_LArBackend" => "larevt_CalibrationDBI_LArBackend",
		        "CalibrationDBI_Providers" => "larevt_CalibrationDBI_Providers",
                        "Filters" => "larevt_Filters",
                        "SpaceCharge" => "larevt_SpaceCharge",
			"CalWireAna_module" => "larevt_CalData_CalWireAna_module",
			"CalWire_module" => "larevt_CalData_CalWire_module",
			"CalWireT962_module" => "larevt_CalData_CalWireT962_module",
			"DumpWires_module" => "larevt_CalData_DumpWires_module",
			"SIOVChannelStatusService_service" => "larevt_CalibrationDBI_Services_SIOVChannelStatusService_service",
			"SIOVDetPedestalService_service" => "larevt_CalibrationDBI_Services_SIOVDetPedestalService_service",
			"ADCFilter_module" => "larevt_Filters_ADCFilter_module",
			"EmptyFilter_module" => "larevt_Filters_EmptyFilter_module",
			"EventFilter_module" => "larevt_Filters_EventFilter_module",
			"FinalStateParticleFilter_module" => "larevt_Filters_FinalStateParticleFilter_module",
			"MuonFilter_module" => "larevt_Filters_MuonFilter_module",
			"SimpleChannelStatusService_service" => "larevt_Filters_SimpleChannelStatusService_service",
			"SmallClusterFilter_module" => "larevt_Filters_SmallClusterFilter_module",
			"SpaceCharge_service" => "larevt_SpaceCharge_SpaceCharge_service",
                        "DetSim" => "larsim_DetSim",
                        "EventGenerator" => "larsim_EventGenerator",
		        "MergeSimSources" => "larsim_LArG4",
                        "LArG4" => "larsim_LArG4",
                        "MCCheater" => "larsim_MCCheater",
                        "MCSTReco" => "larsim_MCSTReco",
                        "PhotonPropagation" => "larsim_PhotonPropagation",
                        "SimFilters" => "larsim_SimFilters",
                        "Simulation" => "larsim_Simulation",
                        "TriggerAlgo" => "larsim_TriggerAlgo",
			"DumpRawDigits_module" => "larsim_DetSim_DumpRawDigits_module",
			"SimWireAna_module" => "larsim_DetSim_SimWireAna_module",
			"WienerFilterAna_module" => "larsim_DetSim_WienerFilterAna_module",
			"CosmicsGen_module" => "larsim_EventGenerator_CRY_CosmicsGen_module",
			"GeneratedEventTimestamp_plugin" => "larsim_EventGenerator_GeneratedEventTimestamp_plugin",
			"PhotonVisibilityService_service" => "larsim_PhotonPropagation_PhotonVisibilityService_service",
                        "LArG4Parameters_service" => "larsim_Simulation_LArG4Parameters_service",
                        "LArVoxelCalculator_service" => "larsim_Simulation_LArVoxelCalculator_service",
                        "TriggerAlgoBase_service" => "larsim_TriggerAlgo_TriggerAlgoBase_service",
                        "TriggerAlgoMicroBoone_service" => "larsim_TriggerAlgo_TriggerAlgoMicroBoone_service",
                        "GeneratedEventTimestamp_plugin" => "larsim_EventGenerator_GeneratedEventTimestamp_plugin",
			"BackTracker_service" => "larsim_MCCheater_BackTracker_service",
                        "ClusterFinder" => "larreco_ClusterFinder",
        		"Segmentation2D" => "larreco_ClusterFinder_TrackShowerSplitter_Segmentation2D",
                        "DirOfGamma" => "larreco_DirOfGamma",
                        "EventFinder" => "larreco_EventFinder",
                        "Genfit" => "larreco_Genfit",
		        "RFFHitFitter" => "larreco_HitFinder",
                        "HitFinder" => "larreco_HitFinder",
                        "MCComp" => "larreco_MCComp",
                        "RecoAlg" => "larreco_RecoAlg",
        		"Cluster3DAlgs" => "larreco_RecoAlg_Cluster3DAlgs",
		        "ClusterRecoUtil" => "larreco_RecoAlg_ClusterRecoUtil",
		        "CMTAlgMatch" => "larreco_RecoAlg_CMTool_CMTAlgMatch",
		        "CMTAlgMerge" => "larreco_RecoAlg_CMTool_CMTAlgMerge",
		        "CMTAlgPriority" => "larreco_RecoAlg_CMTool_CMTAlgPriority",
		        "CMToolApp" => "larreco_RecoAlg_CMTool_CMToolApp",
		        "CMToolBase" => "larreco_RecoAlg_CMTool_CMToolBase",
        		"PMAlg" => "larreco_RecoAlg_PMAlg",
                        "ShowerFinder" => "larreco_ShowerFinder",
        		"ShowerReco3D" => "larreco_ShowerFinder_ShowerReco3D",
                        "SpacePointFinder" => "larreco_SpacePointFinder",
                        "TrackFinder" => "larreco_TrackFinder",
                        "VertexFinder" => "larreco_VertexFinder",
                        "WireCell" => "larreco_WireCell",
			"AggregateEvent_module" => "larreco_EventFinder_AggregateEvent_module",
			"EventCheater_module" => "larreco_EventFinder_EventCheater_module",
			"EventMaker_module" => "larreco_EventFinder_EventMaker_module",
			"DumpTracks_module" => "larreco_TrackFinder_DumpTracks_module",
			"HarrisVertexFinder_module" => "larreco_VertexFinder_HarrisVertexFinder_module",
			"LArPandoraAnalysis" => "larpandora_LArPandoraAnalysis",
			"LArPandoraInterface" => "larpandora_LArPandoraInterface",
			"MicroBooNEPandora" => "larpandora_MicroBooNEPandora",
                        "Calorimetry" => "larana_Calorimetry",
                        "CosmicRemoval" => "larana_CosmicRemoval",
		        "FlashHypothesis" => "larana_OpticalDetector",
			"SimPhotonCounter" => "larana_OpticalDetector",
			"FlashHypothesisComparison" => "larana_OpticalDetector",
			"OpFlashAnaAlg" => "larana_OpticalDetector",
                        "OpticalDetector" => "larana_OpticalDetector",
                        "ParticleIdentification" => "larana_ParticleIdentification",
			"DefaultOpDetResponse_service" => "larana_OpticalDetector_DefaultOpDetResponse_service",
			"MicrobooneOpDetResponse_service" => "larana_OpticalDetector_MicrobooneOpDetResponse_service",
			"OpDigiProperties_service" => "larana_OpticalDetector_OpDigiProperties_service",
			"Chi2ParticleID_module" => "larana_ParticleIdentification_Chi2ParticleID_module",
			"PIDAAnalyzer_module" => "larana_ParticleIdentification_PIDAAnalyzer_module",
			"BezierCalorimetry_module" => "larana_Calorimetry_BezierCalorimetry_module",
			"Calorimetry_module" => "larana_Calorimetry_Calorimetry_module",
			"GeneralCalorimetry_module" => "larana_Calorimetry_GeneralCalorimetry_module",
			"PrintCalorimetry_module" => "larana_Calorimetry_PrintCalorimetry_module",
			"TrackCalorimetry_module" => "larana_Calorimetry_TrackCalorimetry_module",
			"CosmicClusterTagger_module" => "larana_CosmicRemoval_CosmicClusterTagger_module",
			"CRHitRemovalByPCA_module" => "larana_CosmicRemoval_CRHitRemovalByPCA_module",
			"CosmicRemovalAna_module" => "larana_CosmicRemoval_CosmicRemovalAna_module",
			"BeamFlashTrackMatchTagger_module" => "larana_CosmicRemoval_BeamFlashTrackMatchTagger_module",
			"CRHitRemoval_module" => "larana_CosmicRemoval_CRHitRemoval_module",
			"CosmicTrackTagger_module" => "larana_CosmicRemoval_CosmicTrackTagger_module",
			"CosmicPFParticleTagger_module" => "larana_CosmicRemoval_CosmicPFParticleTagger_module",
			"CosmicPCAxisTagger_module" => "larana_CosmicRemoval_CosmicPCAxisTagger_module",
			"FlashClusterMatch_module" => "larana_OpticalDetector_FlashClusterMatch_module",
			"OpHitAna_module" => "larana_OpticalDetector_OpHitAna_module",
			"OpFlashSimpleAna_module" => "larana_OpticalDetector_OpFlashSimpleAna_module",
			"FIFOHistogramAna_module" => "larana_OpticalDetector_FIFOHistogramAna_module",
			"OpticalRecoAna_module" => "larana_OpticalDetector_OpticalRecoAna_module",
			"OpFlashMCTruthAna_module" => "larana_OpticalDetector_OpFlashMCTruthAna_module",
			"OpFlashAna_module" => "larana_OpticalDetector_OpFlashAna_module",
			"LEDCalibrationAna_module" => "larana_OpticalDetector_LEDCalibrationAna_module",
			"SimPhotonCounter_module" => "larana_OpticalDetector_SimPhotonCounter_module",
			"OpticalRawDigitReformatter_module" => "larana_OpticalDetector_OpticalRawDigitReformatter_module",
			"BeamFlashCompatibilityCheck_module" => "larana_OpticalDetector_BeamFlashCompatibilityCheck_module",
			"TrackTimeAssocAna_module" => "larana_OpticalDetector_TrackTimeAssocAna_module",
			"OpMCDigi_module" => "larana_OpticalDetector_OpMCDigi_module",
			"OpFlashFinder_module" => "larana_OpticalDetector_OpFlashFinder_module",
			"OpDigiAna_module" => "larana_OpticalDetector_OpDigiAna_module",
			"OptDetDigitizer_module" => "larana_OpticalDetector_OptDetDigitizer_module",
			"BoDataFrameInput_module" => "larana_OpticalDetector_BoDataFrameInput_module",
			"PMTAna_module" => "larana_OpticalDetector_PMTAna_module",
			"FlashHypothesisAna_module" => "larana_OpticalDetector_FlashHypothesisAna_module",
			"FlashPurityCheckAna_module" => "larana_OpticalDetector_FlashPurityCheckAna_module",
			"TrackTimeAssoc_module" => "larana_OpticalDetector_TrackTimeAssoc_module",
                        "OpHitFinder" => "larana_OpticalDetector_OpHitFinder",
			"PhotonCounterT0Matching_module" => "larana_T0Finder_PhotonCounterT0Matching_module",
			"MCTruthT0Matching_module" => "larana_T0Finder_MCTruthT0Matching_module",
                        "T0Finder" => "larana_T0Finder",
                        "EventDisplay" => "lareventdisplay_EventDisplay",
			"AnalysisDrawingOptions_service" => "lareventdisplay_EventDisplay_AnalysisDrawingOptions_service",
			"ColorDrawingOptions_service" => "lareventdisplay_EventDisplay_ColorDrawingOptions_service",
			"EvdLayoutOptions_service" => "lareventdisplay_EventDisplay_EvdLayoutOptions_service",
			"InfoTransfer_service" => "lareventdisplay_EventDisplay_InfoTransfer_service",
			"RawDrawingOptions_service" => "lareventdisplay_EventDisplay_RawDrawingOptions_service",
			"RecoDrawingOptions_service" => "lareventdisplay_EventDisplay_RecoDrawingOptions_service",
			"SimulationDrawingOptions_service" => "lareventdisplay_EventDisplay_SimulationDrawingOptions_service",
                        "AnalysisExample" => "larexamples_AnalysisExample",
			"AnalysisExample_module" => "larexamples_AnalysisExample_AnalysisExample_module"
		       ); }

foreach my $lib (sort keys %dir_list) {
   next if m&add_subdirectory&i;
   next if m&simple_plugin&i;
   next if m&SUBDIRNAME&i;
   next if m&SUBDIRS&i;
  #s&\b\Q${lib}\E([^\.\s]*\b)([^\.]|$)&$dir_list{$lib}${1}${2}&g and last;
  s&\b\Q${lib}\E\b([^\.]|$)&$dir_list{$lib}${1}${2}&g and last;
}
